/*
 * This file is generated by jOOQ.
 */
package de.ship.db.tables;


import de.ship.db.CommonDd;
import de.ship.db.tables.records.VDataquier2MissinglistsRecord;

import java.util.Collection;

import org.jooq.Condition;
import org.jooq.Field;
import org.jooq.Name;
import org.jooq.PlainSQL;
import org.jooq.QueryPart;
import org.jooq.SQL;
import org.jooq.Schema;
import org.jooq.Select;
import org.jooq.Stringly;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.TableOptions;
import org.jooq.impl.DSL;
import org.jooq.impl.SQLDataType;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class VDataquier2Missinglists extends TableImpl<VDataquier2MissinglistsRecord> {

    private static final long serialVersionUID = 1L;

    /**
     * The reference instance of
     * <code>common_dd.v_dataquier2_missinglists</code>
     */
    public static final VDataquier2Missinglists V_DATAQUIER2_MISSINGLISTS = new VDataquier2Missinglists();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<VDataquier2MissinglistsRecord> getRecordType() {
        return VDataquier2MissinglistsRecord.class;
    }

    /**
     * The column
     * <code>common_dd.v_dataquier2_missinglists.fk_missinglist</code>.
     */
    public final TableField<VDataquier2MissinglistsRecord, Integer> FK_MISSINGLIST = createField(DSL.name("fk_missinglist"), SQLDataType.INTEGER, this, "");

    /**
     * The column <code>common_dd.v_dataquier2_missinglists.CODE_VALUE</code>.
     */
    public final TableField<VDataquier2MissinglistsRecord, Integer> CODE_VALUE = createField(DSL.name("CODE_VALUE"), SQLDataType.INTEGER, this, "");

    /**
     * The column <code>common_dd.v_dataquier2_missinglists.CODE_LABEL</code>.
     */
    public final TableField<VDataquier2MissinglistsRecord, String> CODE_LABEL = createField(DSL.name("CODE_LABEL"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>common_dd.v_dataquier2_missinglists.CODE_CLASS</code>.
     */
    public final TableField<VDataquier2MissinglistsRecord, String> CODE_CLASS = createField(DSL.name("CODE_CLASS"), SQLDataType.CLOB, this, "");

    /**
     * The column
     * <code>common_dd.v_dataquier2_missinglists.CODE_CLASS_QS</code>.
     */
    public final TableField<VDataquier2MissinglistsRecord, String> CODE_CLASS_QS = createField(DSL.name("CODE_CLASS_QS"), SQLDataType.CLOB, this, "");

    private VDataquier2Missinglists(Name alias, Table<VDataquier2MissinglistsRecord> aliased) {
        this(alias, aliased, (Field<?>[]) null, null);
    }

    private VDataquier2Missinglists(Name alias, Table<VDataquier2MissinglistsRecord> aliased, Field<?>[] parameters, Condition where) {
        super(alias, null, aliased, parameters, DSL.comment(""), TableOptions.view("""
        create view "v_dataquier2_missinglists" as  SELECT mv.fk_missinglist,
         mc.num_missingcode AS "CODE_VALUE",
         t.value AS "CODE_LABEL",
         upper(c.name) AS "CODE_CLASS",
         upper(qc.name) AS "CODE_CLASS_QS"
        FROM ((((((common_dd.t_core_missingvalue mv
          LEFT JOIN common_dd.t_core_missingmaster mm ON ((mm.pk = mv.fk_missingmaster)))
          LEFT JOIN common_dd.t_core_translation t ON (((t.fk_trans_key = mm.fk_lang) AND (t.isocode = 'en'::common_dd.enum_isocode) AND (t.category = 'crf'::common_dd.enum_trans_category))))
          LEFT JOIN common_dd.t_core_missingclass c ON ((c.pk = mv.fk_missingclass)))
          LEFT JOIN common_dd.t_core_missingclass qc ON ((qc.pk = mv.fk_missingclass_qs)))
          LEFT JOIN common_dd.t_dm_missingvalue dmv ON ((dmv.fk_core_missingvalue = mv.pk)))
          LEFT JOIN common_dd.t_dm_missingcode mc ON ((mc.pk = dmv.fk_missingcode)));
        """), where);
    }

    /**
     * Create an aliased <code>common_dd.v_dataquier2_missinglists</code> table
     * reference
     */
    public VDataquier2Missinglists(String alias) {
        this(DSL.name(alias), V_DATAQUIER2_MISSINGLISTS);
    }

    /**
     * Create an aliased <code>common_dd.v_dataquier2_missinglists</code> table
     * reference
     */
    public VDataquier2Missinglists(Name alias) {
        this(alias, V_DATAQUIER2_MISSINGLISTS);
    }

    /**
     * Create a <code>common_dd.v_dataquier2_missinglists</code> table reference
     */
    public VDataquier2Missinglists() {
        this(DSL.name("v_dataquier2_missinglists"), null);
    }

    @Override
    public Schema getSchema() {
        return aliased() ? null : CommonDd.COMMON_DD;
    }

    @Override
    public VDataquier2Missinglists as(String alias) {
        return new VDataquier2Missinglists(DSL.name(alias), this);
    }

    @Override
    public VDataquier2Missinglists as(Name alias) {
        return new VDataquier2Missinglists(alias, this);
    }

    @Override
    public VDataquier2Missinglists as(Table<?> alias) {
        return new VDataquier2Missinglists(alias.getQualifiedName(), this);
    }

    /**
     * Rename this table
     */
    @Override
    public VDataquier2Missinglists rename(String name) {
        return new VDataquier2Missinglists(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public VDataquier2Missinglists rename(Name name) {
        return new VDataquier2Missinglists(name, null);
    }

    /**
     * Rename this table
     */
    @Override
    public VDataquier2Missinglists rename(Table<?> name) {
        return new VDataquier2Missinglists(name.getQualifiedName(), null);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VDataquier2Missinglists where(Condition condition) {
        return new VDataquier2Missinglists(getQualifiedName(), aliased() ? this : null, null, condition);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VDataquier2Missinglists where(Collection<? extends Condition> conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VDataquier2Missinglists where(Condition... conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VDataquier2Missinglists where(Field<Boolean> condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VDataquier2Missinglists where(SQL condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VDataquier2Missinglists where(@Stringly.SQL String condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VDataquier2Missinglists where(@Stringly.SQL String condition, Object... binds) {
        return where(DSL.condition(condition, binds));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VDataquier2Missinglists where(@Stringly.SQL String condition, QueryPart... parts) {
        return where(DSL.condition(condition, parts));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VDataquier2Missinglists whereExists(Select<?> select) {
        return where(DSL.exists(select));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VDataquier2Missinglists whereNotExists(Select<?> select) {
        return where(DSL.notExists(select));
    }
}
